﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode
{
    [StorableClass]
    public class ShotPower : CodeNode
    {
        public override int MinimumArity { get { return 0; } }
        public override int MaximumArity { get { return 0; } }

        [Storable]
        public override string Prefix { get; set; }

        [Storable]
        public override string Suffix { get; set; }

        [StorableConstructor]
        private ShotPower(bool deserializing) : base(deserializing) { }
        private ShotPower(ShotPower original, Cloner cloner)
            : base(original, cloner)
        {
        }

        public ShotPower()
            : base("ShotPower", "The power of a shot between 0.1 and 3.")
        {
        }

        public override ISymbolicExpressionTreeNode CreateTreeNode()
        {
            return new ShotPowerTreeNode();
        }

        public override IDeepCloneable Clone(Cloner cloner)
        {
            return new ShotPower(this, cloner);
        }

        public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children)
        {
            return " " + ((ShotPowerTreeNode)node).Value + " ";
        }
    }
}